/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
  See OTBCopyright.txt for details.


     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notices for more information.

=========================================================================*/
#ifndef __otbApplication_h
#define __otbApplication_h

#include "itkLightObject.h"
#include "otbApplicationOptions.h"
#include "otbApplicationDescriptor.h"

namespace otb
{

/**
 * \class Application
 * \brief Container for a processing chain, which can be wrapped to CLI exe, GUI, QGis plugin, ...
 *
 * \see ApplicationDescriptor, ApplicationOptionsResult
 */
class ITK_EXPORT Application : public itk::Object
{
public:
  /** Standard class typedefs. */
  typedef Application                   Self;
  typedef itk::Object                   Superclass;
  typedef itk::SmartPointer<Self>       Pointer;
  typedef itk::SmartPointer<const Self> ConstPointer;

  virtual int Describe(otb::ApplicationDescriptor* descriptor) = 0;

  virtual int Execute(otb::ApplicationOptionsResult* result) = 0;

};


}

#endif // __otbApplicationOptions_h_
