/***************************************************************************
                          ApplicationQgisPlugin.cpp  -  description
                             -------------------
    begin                : August 6th, 2009
    copyright            : (C) 2009 by Marco Hugentobler
    email                : marco dot hugentobler at karto dot baug dot ethz dot ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "otbApplicationQgisPlugin.h"

#include "qgis.h"
#include "qgisinterface.h"

namespace otb
{

ApplicationQgisPlugin::ApplicationQgisPlugin ( QgisInterface* iface, otb::Application* appli, std::string name, std::string desc)
: m_Iface( iface )
, m_Action( 0 )
, m_Application(appli)
, m_Name(name)
, m_Desc(desc)
{
}

ApplicationQgisPlugin::~ApplicationQgisPlugin()
{
}

void ApplicationQgisPlugin::initGui()
{
  //create Action
  if ( m_Iface )
  {
    //Add Raster reprojection Tool
    m_Action = new QAction( QIcon( ":/otb_small.png" ), QString(m_Name.c_str()), this );
    // Set the what's this text
    m_Action->setWhatsThis( QString(m_Desc.c_str()) );
    // Connect the action to the run
    connect( m_Action, SIGNAL( triggered() ), this, SLOT( run() ) );
    // Add the icon to the toolbar
    m_Iface->addToolBarIcon( m_Action );
    m_Iface->addPluginToMenu( "&OTB", m_Action );
  }
}

void ApplicationQgisPlugin::unload()
{
  if ( m_Iface )
  {
    m_Iface->removePluginMenu( tr( "&OTB" ), m_Action );
    m_Iface ->removeToolBarIcon( m_Action );
    delete m_Action;
  }
}

void ApplicationQgisPlugin::run()
{
  m_ApplicationGui = new otb::ApplicationQgisWidget(m_Application, m_Iface);
  m_ApplicationGui->CreateGui();
  m_ApplicationGui->show();
}

}
