/***************************************************************************
                          ApplicationQgisPlugin.h  -  description
                             -------------------
    begin                : August 6th, 2009
    copyright            : (C) 2009 by Marco Hugentobler
    email                : marco dot hugentobler at karto dot baug dot ethz dot ch
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __otbApplicationQgisPlugin_h
#define __otbApplicationQgisPlugin_h

#define GUI_EXPORT
#define CORE_EXPORT

#include "otbApplication.h"
#include "otbApplicationQgisWidget.h"
#include "qgisplugin.h"
#include <QObject>
#include "qgsrasterlayer.h"

class QgisInterface;
class QgsMapCanvas;
class QAction;

namespace otb
{

/**A generic plugin for Orfeo Toolbox applications*/
class ApplicationQgisPlugin: public QObject, public QgisPlugin
{
    Q_OBJECT
  public:
    ApplicationQgisPlugin(QgisInterface* iface, otb::Application* appli, std::string name, std::string desc);
    ~ApplicationQgisPlugin();

    /**initialize connection to GUI*/
    void initGui();
    /**Unload the plugin and cleanup the GUI*/
    void unload();

  private slots:
    /**Show plugin*/
    void run();

  private:
    QgisInterface* m_Iface;
    QAction* m_Action;

    otb::Application::Pointer m_Application;
    otb::ApplicationQgisWidget* m_ApplicationGui;
    std::string m_Name;
    std::string m_Desc;
};

}
#endif // __otbApplicationQgisPlugin_h
