/*=========================================================================

 Program:   ORFEO Toolbox
 Language:  C++
 Date:      $Date$
 Version:   $Revision$


 Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
 See OTBCopyright.txt for details.


 This software is distributed WITHOUT ANY WARRANTY; without even
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE.  See the above copyright notices for more information.

 =========================================================================*/
#ifndef __otbApplicationQgisWidget_h
#define __otbApplicationQgisWidget_h

#include <QtGui>

#include "otbApplication.h"
#include "otbApplicationQtWidget.h"

class QgisInterface;

namespace otb
{

/**
 * \class ApplicationQgisWidget
 */
class ITK_EXPORT ApplicationQgisWidget: public ApplicationQtWidget
{
  Q_OBJECT

public:
  ApplicationQgisWidget(otb::Application* appli, QgisInterface* iFace);
  ~ApplicationQgisWidget();

protected:
  virtual QWidget* CreateInputImageWidget (const OptionType& option);
  virtual QWidget* CreateOutputImageWidget(const OptionType& option);

protected slots:
  virtual void EndExecute();

private slots:
  void SetInputImageValue(QWidget*);

private:
  QComboBox* m_Combobox;
  QgisInterface* m_QgisIFace;
  QSignalMapper* m_ComboboxMapper;
};

}

#endif // __otbApplicationQgisWidget_h_
