/*=========================================================================

 Program:   ORFEO Toolbox
 Language:  C++
 Date:      $Date$
 Version:   $Revision$


 Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
 See OTBCopyright.txt for details.


 This software is distributed WITHOUT ANY WARRANTY; without even
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE.  See the above copyright notices for more information.

 =========================================================================*/
#ifndef __otbApplicationExecutionThread_h
#define __otbApplicationExecutionThread_h

#include <QtGui>
#include "otbApplication.h"

namespace otb
{

class ITK_EXPORT ApplicationExecutionThread : public QThread
{
  Q_OBJECT

public:
  ApplicationExecutionThread(QObject* parent);

  ~ApplicationExecutionThread();

public:
  void Execute(otb::Application* appli, otb::ApplicationOptionsResult* options);

signals:
  void ReportError(const QString& msg);

protected:
  virtual void run();

private:
  otb::Application::Pointer m_Appli;
  otb::ApplicationOptionsResult::Pointer m_Options;
};

}

#endif // __otbApplicationExecutionThread_h_
