/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
  See OTBCopyright.txt for details.


     This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE.  See the above copyright notices for more information.

=========================================================================*/
#ifndef __otbFocusingController_txx
#define __otbFocusingController_txx

#include "otbFocusingController.h"

namespace otb
{
template < class TFocusingModel, class TFocusingView >
FocusingController<TFocusingModel, TFocusingView>
::FocusingController()
{
  m_MasterController  = ControllerType::New();
  m_WorkingController = ControllerType::New();
}


template < class TFocusingModel, class TFocusingView >
void
FocusingController<TFocusingModel, TFocusingView>
::AddSelectAreaHandler()
{
  if( m_FocusingModel.IsNull() || m_FocusingView.IsNull() )
    itkExceptionMacro(<<"m_FocusingModel and m_FocusingView are empty...");

 // Add the change selected area handler
  SelectAreaHandlerPointerType selectAreaHandler = SelectAreaHandlerType::New();
  selectAreaHandler->SetModel(m_FocusingModel);
  selectAreaHandler->SetWidget(m_FocusingView->GetMasterScrollWidget());
  selectAreaHandler->SetRegionGlComponent( m_FocusingView->GetMasterViewer()->GetExtractRegionGlComponent());
  m_MasterController->AddActionHandler(selectAreaHandler);
}

}

#endif
