/*=========================================================================

  $Author: allain $
  $Date: 2005/06/28 11:28:58 $
  $Revision: 1.3 $
  $Id: PireoRegistrationLevelObserver.cxx, v 1.3 2005/06/28 11:28:58 allain Exp $
  $Source: /usr/local/stok/CVS_REPO/Pireo/Code/Registration/NewClassNames/PireoRegistrationLevelObserver.cxx, v $
  $Log: PireoRegistrationLevelObserver.cxx, v $
  Revision 1.3  2005/06/28 11:28:58  allain
  Update

  Revision 1.2  2005/06/24 15:40:09  allain
  Add metric values graph and started registration levels observer

  Revision 1.1  2005/06/15 14:41:20  allain
  Add registration level observer


=========================================================================*/
// Optimizer
#include "itkRegularStepGradientDescentOptimizer.h"
#include "itkConjugateGradientOptimizer.h"
#include "itkOnePlusOneEvolutionaryOptimizer.h"
#include "itkNormalVariateGenerator.h"
#include "itkGradientDescentOptimizer.h"
#include "itkLBFGSModifiedOptimizer.h"

#include "PireoRegistrationLevelObserver.h"
#include "PireoViewer.h"

#include "vtkImageData.h"
#include "math.h"
#include "Structures.h"


PireoRegistrationLevelObserver::PireoRegistrationLevelObserver()
{
}

PireoRegistrationLevelObserver::~PireoRegistrationLevelObserver()
{
}

// When an iterative event occurs on the registration process
// optimizer, automatically this method is called
void PireoRegistrationLevelObserver::Execute(const itk::Object *caller, const itk::EventObject & event)
{
  return;
}

// When an iterative event occurs on the registration process
// optimizer, automatically this method is called
void PireoRegistrationLevelObserver::Execute(itk::Object * object, const itk::EventObject & event)
{

  if ( typeid( event ) != typeid( itk::IterationEvent ) )
    return;


  // Get back the multi-resolution registration object
  RegistrationPointer registration =
    dynamic_cast<RegistrationPointer>( object );


  //OptimizerPointer optimizer = dynamic_cast< OptimizerPointer >(
  //  registration->GetOptimizer() );

  if ( registration->GetCurrentLevel() == 1 )
  {
    m_pireoviewer->GetRegistration()->ChangeParametersFromRegistrationLevelObserver();
    itk::RegularStepGradientDescentOptimizer* RSGO = dynamic_cast< itk::RegularStepGradientDescentOptimizer* >( registration->GetOptimizer() );
    /*RSGO->SetMaximumStepLength( dynamic_cast<
    itk::RegularStepGradientDescentOptimizer*
    >(m_pireoviewer->GetRegistration()->GetOptimizer())->GetMaximumStepLength()); */
    std::cout<<"OPTIM  :"<< RSGO->GetMaximumStepLength()<<std::endl;
  }
}

// Attache PireoViewer object to this observer
void PireoRegistrationLevelObserver::SetPireoViewer(PireoViewer* vi)
{
  m_pireoviewer = vi;
}

/*void PireoRegistrationLevelObserver::GetOptimizer(const itk::Object * object)
{
  // Get back registration optimizer type
  RegistrationOptimizerParameter OP;
  m_pireoviewer->GetRegistration()->GetOptimizerType(&OP);

  switch(OP)
    {
    case RSG :
    {
    const itk::RegularStepGradientDescentOptimizer* RSGO = dynamic_cast< const itk::RegularStepGradientDescentOptimizer* >( object );
    break;
    }
    case LBFGS:
    {
    const  itk::LBFGSModifiedOptimizer* LBFGSO = dynamic_cast< const itk::LBFGSModifiedOptimizer* >( object );
    break;
    }
    case CG:
    {
    const  itk::ConjugateGradientOptimizer* CGO = dynamic_cast< const itk::ConjugateGradientOptimizer* >( object );
    break;
    }
    case OPOE:
    {
    const  itk::OnePlusOneEvolutionaryOptimizer* OPEO = dynamic_cast< const itk::OnePlusOneEvolutionaryOptimizer* >( object );
    break;
    }
    case GD:
    {
    const  itk::GradientDescentOptimizer* GDO = dynamic_cast< const itk::GradientDescentOptimizer* >( object );
    break;
    }
    }
}*/
