#include "otbPolarimetricSynthesisApplicationModel.h"
#include "otbPolarimetricSynthesisApplicationViewGUI.h"
#include "otbPolarimetricSynthesisApplicationController.h"
#include <FL/Fl.H>

#include "otbI18n.h"

using namespace otb;

int main(int argc, char* argv[])
{
  otbI18nMacro();
  PolarimetricSynthesisApplicationModel::Pointer model = PolarimetricSynthesisApplicationModel::GetInstance();
  PolarimetricSynthesisApplicationController::Pointer controller = PolarimetricSynthesisApplicationController::New();
  PolarimetricSynthesisApplicationViewGUI::Pointer view = PolarimetricSynthesisApplicationViewGUI::New();
  view->SetPolarimetricSynthesisApplicationController(controller);
  controller->SetView(view);

  Fl::run();

  return EXIT_SUCCESS;
}
