/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbLevelSetSegmentationController.h"

namespace otb
{

LevelSetSegmentationController::LevelSetSegmentationController()
{}

LevelSetSegmentationController::~LevelSetSegmentationController()
{}

void LevelSetSegmentationController::ChangeSigma(double sigma)
{
  m_Model->SetSigma(sigma);
}

void LevelSetSegmentationController::ChangeSigmoidAlpha(double alpha)
{
  m_Model->SetSigmoidAlpha(alpha);
}

void LevelSetSegmentationController::ChangeSigmoidBeta(double beta)
{
  m_Model->SetSigmoidBeta(beta);
}

void LevelSetSegmentationController::ChangeTimeThreshold(double timeThreshold)
{
  m_Model->SetTimeThreshold(timeThreshold);
}

void LevelSetSegmentationController::ChangeStoppingTime(double stoppingTime)
{
  m_Model->SetStoppingTime(stoppingTime);
  m_View->vTimeThreshold->maximum(stoppingTime);
}

void LevelSetSegmentationController::ClearSeeds()
{
  m_Model->ClearSeeds();
}

void LevelSetSegmentationController::SeedSelected(IndexType& seed)
{
  m_Model->AddSeed(seed);
}

} // end namespace otb
