/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbPreprocessingController.h"

namespace otb
{

PreprocessingController::PreprocessingController()
{}

PreprocessingController::~PreprocessingController()
{}

void PreprocessingController::ChangeNumberOfIterations(unsigned int numberOfIterations)
{
  m_Model->SetNumberOfIterations(numberOfIterations);
}

void PreprocessingController::ChangeTimeStep(double timeStep)
{
  m_Model->SetTimeStep(timeStep);
}

void PreprocessingController::ChangeAlpha(double alpha)
{
  m_Model->SetAlpha(alpha);
}

void PreprocessingController::EnableSmoothing()
{
  m_Model->SetUseSmoothing(true);
  m_View->vNumberOfIterations->activate();
  m_View->vTimeStep->activate();
}

void PreprocessingController::DisableSmoothing()
{
  m_Model->SetUseSmoothing(false);
  m_View->vNumberOfIterations->deactivate();
  m_View->vTimeStep->deactivate();
}

void PreprocessingController::EnableEdgeEnhancement()
{
  m_Model->SetUseEdgeEnhancement(true);
  m_View->vAlpha->activate();
}

void PreprocessingController::DisableEdgeEnhancement()
{
  m_Model->SetUseEdgeEnhancement(false);
  m_View->vAlpha->deactivate();
}

} // end namespace otb
