/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#ifndef __otbSVMBasedRegionGrowingSegmentationController_h
#define __otbSVMBasedRegionGrowingSegmentationController_h

#include "otbSVMBasedRegionGrowingSegmentationControllerInterface.h"
#include "otbSVMBasedRegionGrowingSegmentationViewGUI.h"

namespace otb
{
class SVMBasedRegionGrowingSegmentationController
      : public SVMBasedRegionGrowingSegmentationControllerInterface
{
public:
  /** Standard class typedefs */
  typedef SVMBasedRegionGrowingSegmentationController          Self;
  typedef itk::Object                      Superclass;
  typedef itk::SmartPointer<Self>          Pointer;
  typedef itk::SmartPointer<const Self>    ConstPointer;

  typedef otb::SVMBasedRegionGrowingSegmentationViewGUI ViewType;
  typedef ViewType::Pointer         ViewPointerType;

  /** Standard type macros */
  itkTypeMacro(SVMBasedRegionGrowingSegmentationController, Superclass);
  itkNewMacro(Self);

  itkSetObjectMacro(View, ViewType);

  virtual void ClearSeeds();
  virtual void ChangeNumberOfSads(unsigned int nb);
  virtual void ChangeNumberOfThresholds(unsigned int nb);
  virtual void PixelDragged(IndexType& index);
  virtual void MouseReleased();
  virtual void ManualUpdate();

protected:
  /** Constructor */
  SVMBasedRegionGrowingSegmentationController();
  /** Destructor */
  ~SVMBasedRegionGrowingSegmentationController();

private:
  SVMBasedRegionGrowingSegmentationController(const Self&); //purposely not implemented
  void operator=(const Self&); //purposely not implemented

  /** Pointer to the view */
  ViewPointerType m_View;

};
} //end namespace otb

#endif
