/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#ifndef __otbVectorizationController_h
#define __otbVectorizationController_h

#include "otbVectorizationControllerInterface.h"
#include "otbVectorizationViewGUI.h"

namespace otb
{
class VectorizationController
      : public VectorizationControllerInterface
{
public:
  /** Standard class typedefs */
  typedef VectorizationController          Self;
  typedef itk::Object                      Superclass;
  typedef itk::SmartPointer<Self>          Pointer;
  typedef itk::SmartPointer<const Self>    ConstPointer;

  typedef otb::VectorizationViewGUI ViewType;
  typedef ViewType::Pointer         ViewPointerType;

  /** Standard type macros */
  itkTypeMacro(VectorizationController, Superclass);
  itkNewMacro(Self);

  itkSetObjectMacro(View, ViewType);

  virtual void ChangeTolerance(double tolerance);

protected:
  /** Constructor */
  VectorizationController();
  /** Destructor */
  ~VectorizationController();

private:
  VectorizationController(const Self&); //purposely not implemented
  void operator=(const Self&); //purposely not implemented

  /** Pointer to the view */
  ViewPointerType m_View;

};
} //end namespace otb

#endif
