#include "otbSVMBasedRegionGrowingSegmentationController.h"
#include "otbSVMBasedRegionGrowingSegmentationViewGUI.h"
#include "otbVectorizationController.h"
#include "otbVectorizationViewGUI.h"
#include "otbImageFileReader.h"
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>

#include "otbI18n.h"

int main(int argc, char* argv[])
{
  otbI18nMacro();

  typedef otb::SVMBasedRegionGrowingSegmentationModel SVMBasedRegionGrowingModelType;
  typedef SVMBasedRegionGrowingModelType::InputMSImageType ImageType;
  typedef otb::SVMBasedRegionGrowingSegmentationController SVMBasedRegionGrowingControllerType;
  typedef otb::SVMBasedRegionGrowingSegmentationViewGUI    SVMBasedRegionGrowingViewType;
  typedef otb::ImageFileReader<ImageType> ReaderType;

  ReaderType::Pointer reader = ReaderType::New();
  reader->SetFileName(argv[1]);
  reader->Update();

  SVMBasedRegionGrowingControllerType::Pointer controller2 = SVMBasedRegionGrowingControllerType::New();

  Fl_Double_Window window2(670, 350,"SVM based region growing segmentation");
  SVMBasedRegionGrowingViewType::Pointer view2 = SVMBasedRegionGrowingViewType::New();
  controller2->SetView(view2);
  view2->SetSVMBasedRegionGrowingSegmentationController(controller2);
  view2->resize(0, 0, 670, 350);
  window2.resizable(view2);
  window2.end();

  SVMBasedRegionGrowingModelType::Pointer model2 = otb::SVMBasedRegionGrowingSegmentationModel::GetInstance();
  model2->SetInputImage(reader->GetOutput());

  ImageType::SizeType size2= view2->GetIdealSize();

  window2.resize(0, 0, size2[0], size2[1]);
  window2.show();
  view2->show();
  view2->redraw();
  Fl::run();

  window2.remove(view2.GetPointer());
  return EXIT_SUCCESS;
}
