#include "otbStereoscopicApplicationModel.h"
#include "otbStereoscopicApplicationViewGUI.h"
#include "otbStereoscopicApplicationController.h"
#include <FL/Fl.H>

#include "otbI18n.h"

using namespace otb;

int main(int argc, char* argv[])
{
  otbI18nMacro();

  StereoscopicApplicationModel::Pointer model = StereoscopicApplicationModel::GetInstance();
  StereoscopicApplicationController::Pointer controller = StereoscopicApplicationController::New();
  StereoscopicApplicationViewGUI::Pointer view = StereoscopicApplicationViewGUI::New();
  view->SetStereoscopicApplicationController(controller);
  controller->SetView(view);

  Fl::run();

  return EXIT_SUCCESS;
}
