/*=========================================================================

 Program:   ORFEO Toolbox
 Language:  C++
 Date:      $Date$
 Version:   $Revision$


 Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
 See OTBCopyright.txt for details.


 This software is distributed WITHOUT ANY WARRANTY; without even
 the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
 PURPOSE.  See the above copyright notices for more information.

 =========================================================================*/

#include "otbApplication.h"


namespace otb
{

class ITK_EXPORT HOGObjectDetector: public otb::Application
{
public:
  /** Standard class typedefs. */
  typedef HOGObjectDetector                Self;
  typedef otb::Application              Superclass;
  typedef itk::SmartPointer<Self>       Pointer;
  typedef itk::SmartPointer<const Self> ConstPointer;

  /** Standard macro */
  itkNewMacro(Self);
  itkTypeMacro(Self, otb::Application);

  int Describe(otb::ApplicationDescriptor* descriptor);

  int Execute(otb::ApplicationOptionsResult* parseResult);

};

}
