/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbImageLayerRenderingModel.h"
#include "otbFocusingView.h"
#include "otbFocusingModel.h"
#include "itkRGBAPixel.h"
#include "otbImage.h"


int otbFocusingViewNew(int argc, char* argv[])
{


  // typedefs
  typedef double                                               PixelType;
  typedef itk::RGBAPixel<unsigned char>                        RGBPixelType;
  typedef otb::VectorImage<PixelType, 2>                       InputImageType;
  typedef otb::Image<RGBPixelType, 2>                          OutputImageType;
  typedef otb::FocusingModel<InputImageType, OutputImageType> ModelType;
  typedef otb::FocusingView<ModelType>                        ViewType;
  //typedef otb::FocusingController<ModelType, ViewType>        ControllerType;
  typedef ViewType::FocusingControllerType                    ControllerType;

  ViewType::Pointer   lfView  = ViewType::New();
  ModelType::Pointer  lfModel = ModelType::New();
  ControllerType::Pointer  lfController = ControllerType::New();

  return EXIT_SUCCESS;
}
