/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
  See OTBCopyright.txt for details.


  This software is distributed WITHOUT ANY WARRANTY; without even
  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
  PURPOSE.  See the above copyright notices for more information.

=========================================================================*/
#include "itkExceptionObject.h"

#include "otbMinimumMaximumVectorImageFilter.h"
#include "otbVectorImage.h"
#include "otbImageFileReader.h"

int otbMinimumMaximumVectorImageFilterTest(int argc, char * argv[])
{
  typedef double                                          PixelType;
  const int                                               Dimension = 2;
  typedef otb::VectorImage<PixelType, Dimension>           ImageType;
  typedef otb::ImageFileReader<ImageType>                 ReaderType;
  typedef otb::MinimumMaximumVectorImageFilter<ImageType> FilterType;

  // Instantiating object
  FilterType::Pointer object = FilterType::New();
  ReaderType::Pointer reader = ReaderType::New();

  reader->SetFileName(argv[1]);
  object->SetInput( reader->GetOutput() );
  object->Update();

  std::cout<<object->GetMinimumOutput()->Get()<<std::endl;
  std::cout<<object->GetMaximumOutput()->Get()<<std::endl;

  return EXIT_SUCCESS;
}
