/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbFineRegistrationApplicationModel.h"
#include "otbMacro.h"

int otbFineRegistrationApplicationModelTestCase1(int argc, char* argv[])
{
  if (argc!=3)
  {
    std::cerr<<"Usage: "<<argv[0]<<" movingName fixedName "<<std::endl;
    return EXIT_FAILURE;
  }

  const char * movingName = argv[1];
  const char * fixedName = argv[2];

  typedef otb::FineRegistrationApplicationModel ModelType;

  // model instance
  ModelType::Pointer model = otb::FineRegistrationApplicationModel::GetInstance();

  otbTestingCheckValidCommand(   model->OpenPair( movingName, fixedName) );
  otbTestingCheckNotValidCommand( model->OpenPair( "", "") );
  otbTestingCheckNotValidCommand( model->OpenPair( movingName, "") );
  otbTestingCheckNotValidCommand( model->OpenPair( "", fixedName) );

  return EXIT_SUCCESS;
}
