/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbFineRegistrationApplicationModel.h"
#include "otbMacro.h"

int otbFineRegistrationApplicationModelTestCase2(int argc, char* argv[])
{
  if (argc!=3)
  {
    std::cerr<<"Usage: "<<argv[0]<<" disparityMapName registeredImageName"<<std::endl;
    return EXIT_FAILURE;
  }

  const char * disparityMapName = argv[1];
  const char * registeredImageName = argv[2];

  typedef otb::FineRegistrationApplicationModel ModelType;
  typedef ModelType::RadiusType RadiusType;

  // model instance
  ModelType::Pointer model = otb::FineRegistrationApplicationModel::GetInstance();

  otbTestingCheckNotValidCommand(   model->SaveDisparityMap(disparityMapName) );
  otbTestingCheckNotValidCommand(   model->SaveRegisteredImage(registeredImageName) );

  otbTestingCheckNotValidCommand( model->RunDeformationFieldEstimation()  );
  otbTestingCheckNotValidCommand( model->RunImageExtraction()  );

  return EXIT_SUCCESS;
}
