/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbFineRegistrationApplicationModel.h"
#include "otbMacro.h"

int otbFineRegistrationApplicationModelTestCase3(int argc, char* argv[])
{
  if (argc!=5)
  {
    std::cerr<<"Usage: "<<argv[0]<<" movingName1 fixedName1 movingName2 fixedName2 "<<std::endl;
    return EXIT_FAILURE;
  }

  const char * movingName1 = argv[1];
  const char * fixedName1 = argv[2];
  const char * movingName2 = argv[3];
  const char * fixedName2 = argv[4];


  typedef otb::FineRegistrationApplicationModel ModelType;

  // model instance
  ModelType::Pointer model = otb::FineRegistrationApplicationModel::GetInstance();

  otbTestingCheckValidCommand(   model->OpenPair( movingName1, fixedName1) );
  otbTestingCheckNotValidCommand(   model->OpenPair( movingName2, fixedName2) );
  otbTestingCheckValidCommand( model->ClosePair() );
  otbTestingCheckValidCommand( model->OpenPair( movingName2, fixedName2) );

  return EXIT_SUCCESS;
}
