/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "itkExceptionObject.h"
#include "otbImageToDBRegistrationModel.h"
#include "otbImageToDBRegistrationViewGUI.h"
#include "otbImageToDBRegistrationController.h"
#include "otbImageFileReader.h"

using namespace otb;

int otbImageToDBRegistrationNew(int argc, char* argv[])
{

  ImageToDBRegistrationModel::Pointer model = ImageToDBRegistrationModel::GetInstance();
  ImageToDBRegistrationController::Pointer controller = ImageToDBRegistrationController::New();
  ImageToDBRegistrationViewGUI::Pointer view = ImageToDBRegistrationViewGUI::New();
  view->SetImageToDBRegistrationController(controller);
  controller->SetView(view);

  return EXIT_SUCCESS;
}
