/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/

#include "itkExceptionObject.h"
#include "otbImageToDBRegistrationController.h"
#include "otbImageToDBRegistrationViewGUI.h"
#include "otbMsgReporter.h"

int otbImageToDBRegistrationOpenClose(int argc, char* argv[])
{
  typedef otb::ImageToDBRegistrationController ControllerType;
  typedef otb::ImageToDBRegistrationViewGUI ViewType;
  
  ControllerType::Pointer controller = ControllerType::New();
  ViewType::Pointer view = ViewType::New();
  controller->SetView(view);
  controller->AddHandlers();
  view->SetImageToDBRegistrationController(controller);
  
  view->InitWidgets();
  view->Show();

  if(argc==2)
    {
      view->GetImageToDBRegistrationController()->OpenInputImage(argv[1]);
      Fl::check();
    }
  
  if(argc==3)
    {
      view->GetImageToDBRegistrationController()->OpenInputImage(argv[2]);
      Fl::check();
    }
  
  if(argc==4)
    {
      view->GetImageToDBRegistrationController()->OpenInputImage(argv[3]);
      Fl::check();
    }
  
  view->Quit();

  return EXIT_SUCCESS;

}
