/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/

#include "itkExceptionObject.h"
#include "otbImageToDBRegistrationController.h"
#include "otbImageToDBRegistrationViewGUI.h"
#include "itkIndex.h"
#include "otbImageToDBRegistrationEnum.h"

int otbImageToDBRegistrationRunDBImage(int argc, char* argv[])
{
  typedef otb::ImageToDBRegistrationController ControllerType;
  typedef otb::ImageToDBRegistrationViewGUI ViewType;
 
  ControllerType::Pointer controller = ControllerType::New();
  ViewType::Pointer view = ViewType::New();
  controller->SetView(view);
  controller->AddHandlers();
  view->SetImageToDBRegistrationController(controller);
 
  view->InitWidgets();
  view->Show();

  controller->OpenInputImage(argv[1]);
  Fl::check();

  itk::Index<> index1, index2;
  index1.Fill(200);
  index2.Fill(300);
  controller->GetFocusingVisuController()->GetFocusingModel()->SetExtractRegionByIndex( index1, index2 );
  controller->GetFocusingVisuController()->GetFocusingModel()->Update();
  Fl::check();

  view->RunOverExtract();
  Fl::check();

  view->gDBRef->value(1);
  view->gDBRef->do_callback();
  Fl::check();

  view->RunOverExtract();
  Fl::check();

  view->gImageRef->value(1);
  view->gImageRef->do_callback();
  Fl::check();

  view->RunOverExtract();
  Fl::check();

  return EXIT_SUCCESS;
}
