/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
  See OTBCopyright.txt for details.


  This software is distributed WITHOUT ANY WARRANTY; without even
  the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
  PURPOSE.  See the above copyright notices for more information.

=========================================================================*/
#include "itkExceptionObject.h"

#include "otbBlackImage.h"
#include "otbImage.h"
#include "otbImageFileWriter.h"

int otbBlackImageTest(int argc, char * argv[])
{
  typedef double InputPixelType;
  const int Dimension = 2;
  typedef otb::Image<InputPixelType, Dimension> InputImageType;
  typedef otb::ImageFileWriter<InputImageType> WriterType;
  typedef otb::BlackImage<InputImageType> FilterType;

  // Instantiating object
  FilterType::Pointer object = FilterType::New();
  WriterType::Pointer writer = WriterType::New();

  FilterType::SizeType size;
  size[0] = atoi(argv[2]);
  size[1] = atoi(argv[2]);
  FilterType::IndexType id;
  id[0] = atoi(argv[3]);
  id[1] = atoi(argv[3]);

  object->SetSize(size);
  object->SetIndex(id);
  object->SetValue(strtod(argv[4], NULL));

  writer->SetFileName(argv[1]);
  writer->SetInput(object->GetOutput());
  writer->Update();

  return EXIT_SUCCESS;
}
