/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbObjectCountingModel.h"
#include "otbMacro.h"


int otbObjectCountingApplicationModelPolygon(int argc, char* argv[])
{
  typedef otb::ObjectCountingModel ModelType;
  typedef ModelType::IndexType IndexType;

  ModelType::Pointer model = ModelType::GetInstance();

  IndexType id1;
  id1[0] = 12;
  id1[1] = 12;

  otbTestingCheckNotValidCommand(       model->ErasePolygon(id1) );
  otbTestingCheckValidCommand  (       model->NewPolygon(id1) );

  IndexType id2;
  id2[0] = 112;
  id2[1] = 112;
  otbTestingCheckNotValidCommand(       model->ErasePolygon(id2) );

  id1[0] = 12;
  id1[1] = 20;
  otbTestingCheckValidCommand(model->AddPointToCurrentPolygon(id1));

  id1[0] = 20;
  id1[1] = 20;
  otbTestingCheckValidCommand(model->AddPointToCurrentPolygon(id1));

  id1[0] = 20;
  id1[1] = 12;
  otbTestingCheckValidCommand(model->AddPointToCurrentPolygon(id1));

  id1[0]=15;
  id1[1]=15;
  otbTestingCheckValidCommand(          model->ErasePolygon(id1) );

  return EXIT_SUCCESS;
}
