/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbObjectCountingController.h"
#include "otbObjectCountingViewGUI.h"
#include "otbMacro.h"
#include "otbMsgReporter.h"

#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>

int otbObjectCountingApplicationPolyManip(int argc, char* argv[])
{
  typedef otb::ObjectCountingViewGUI ViewerType;
  typedef otb::ObjectCountingController ControllerType;
  typedef ControllerType::IndexType IndexType;
  otb::MsgReporter::GetInstance()->SetTitle("ObjectCounting Application");

  ViewerType::Pointer view = ViewerType::New();
  ControllerType::Pointer controller = ControllerType::New();
  view->SetController(controller);
  controller->SetView(view);

  view->Show();

  controller->OpenImage( argv[1] );

  Fl::check();

  IndexType id;
  id[0] = 12;
  id[1] = 12;
  controller->SimpleLeftClick(id);
  Fl::check();
  id[1] = 112;
  controller->SimpleLeftClick(id);
  Fl::check();
  id[0] = 112;
  controller->SimpleLeftClick(id);
  Fl::check();
  id[1] = 12;
  controller->DoubleLeftClick(id);
  Fl::check();


  id[0] = 100;
  id[1] = 200;
  controller->SimpleLeftClick(id);
  Fl::check();
  id[1] = 150;
  controller->SimpleLeftClick(id);
  Fl::check();
  id[0] = 150;
  controller->SimpleLeftClick(id);
  Fl::check();
  id[1] = 200;
  controller->DoubleLeftClick(id);
  Fl::check();


  id[0] = 100;
  id[1] = 100;
  controller->DoubleRightClick(id);
  Fl::check();

  return EXIT_SUCCESS;
}
