/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbObjectCountingController.h"
#include "otbObjectCountingViewGUI.h"
#include "otbMacro.h"
#include "otbMsgReporter.h"

#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>

int otbObjectCountingApplicationQuit(int argc, char* argv[])
{
  otb::ObjectCountingViewGUI::Pointer view = otb::ObjectCountingViewGUI::New();
  otb::ObjectCountingController::Pointer controller = otb::ObjectCountingController::New();
  otb::MsgReporter::GetInstance()->SetTitle("ObjectCounting Application");
  view->SetController(controller);
  controller->SetView(view);

  view->Show();

  controller->OpenImage( argv[1] );

  Fl::check();

  view->Quit();

  return EXIT_SUCCESS;
}
