/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbObjectCountingModel.h"
#include "otbMacro.h"


#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>

int otbObjectCountingModelLearningTest(int argc, char* argv[])
{
  typedef otb::ObjectCountingModel ModelType;
  typedef ModelType::SizeType SizeType;
  typedef ModelType::IndexType IndexType;
  typedef ModelType::RegionType RegionType;

  ModelType::Pointer model = ModelType::GetInstance();


  SizeType qlSize;
  qlSize[0] = 100;
  qlSize[1] = 100;
  model->SetQuicklookSize( qlSize );
  model->OpenImage( argv[1] );
  RegionType region;
  IndexType newIndex;
  newIndex.Fill(0);
  SizeType newSize;
  newSize[0]=416;
  newSize[1]=347;
  region.SetIndex(newIndex);
  region.SetSize(newSize);
  model->SetCurrentRegion(region);
  model->RunImageExtraction();


  IndexType id;
  id[0] = 0;
  id[1] = 0;
  model->NewPolygon(id);
  id[0] = 0;
  id[1] = 5;
  model->AddPointToCurrentPolygon(id);
  id[0] = 5;
  id[1] = 5;
  model->AddPointToCurrentPolygon(id);
  id[0] = 5;
  id[1] = 0;
  model->AddPointToCurrentPolygon(id);


  id[0] = 50;
  id[1] = 280;
  model->NewPolygon(id);
  id[0] = 60;
  id[1] = 280;
  model->AddPointToCurrentPolygon(id);
  id[0] = 60;
  id[1] = 290;
  model->AddPointToCurrentPolygon(id);
  id[0] = 50;
  id[1] = 290;
  model->AddPointToCurrentPolygon(id);


  model->GenerateInputExampleSampleList();

  model->Learning();

  model->Classification();

  return EXIT_SUCCESS;
}
