/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "otbRoadExtractionModel.h"
#include "otbMacro.h"

int RoadExtractionModelTestCase1(int argc, char* argv[])
{
  if (argc!=2)
  {
    std::cerr<<"Usage: "<<argv[0]<<" inputimageName "<<std::endl;
    return EXIT_FAILURE;
  }

  const char * inputimageName = argv[1];

  typedef otb::RoadExtractionModel ModelType;

  // model instance
  ModelType::Pointer model = otb::RoadExtractionModel::GetInstance();

  otbTestingCheckValidCommand(          model->SetFileName( inputimageName) );


  return EXIT_SUCCESS;
}
