/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include <FL/Fl.H>
#include "otbRoadExtractionModel.h"
#include "otbRoadExtractionController.h"
#include "otbRoadExtractionViewGUI.h"

int RoadExtractionViewTestCase2(int argc, char* argv[])
{

  if (argc!=3)
  {
    std::cerr<<"Usage: "<<argv[0]<<" inputName inputName2"<<std::endl;
    return EXIT_FAILURE;
  }

  const char * inputName = argv[1];
  const char * inputName2 = argv[2];

  typedef otb::RoadExtractionModel ModelType;
  typedef otb::RoadExtractionController ControllerType;
  typedef otb::RoadExtractionViewGUI ViewType;
  typedef ControllerType::IndexType IndexType;


  ControllerType::Pointer controller = ControllerType::New();

  ViewType::Pointer view = ViewType::New();
  view->SetRoadExtractionController(controller);
  controller->SetView(view);
  ModelType::Pointer model = otb::RoadExtractionModel::GetInstance();

  // Scripting
  Fl::check();


  // Open a filename
  controller->SelectFileName(inputName);

  controller->ClearSegments();

  // Open an other filename
  controller->SelectFileName(inputName2);


  return EXIT_SUCCESS;
}
