/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "itkExceptionObject.h"
#include "otbUrbanAreaExtractionModel.h"
#include "otbUrbanAreaExtractionViewGUI.h"
#include "otbUrbanAreaExtractionController.h"
#include "otbImageFileReader.h"

using namespace otb;

int otbUrbanAreaExtractionNew(int argc, char* argv[])
{

  UrbanAreaExtractionModel::Pointer model = UrbanAreaExtractionModel::GetInstance();
  UrbanAreaExtractionController::Pointer controller = UrbanAreaExtractionController::New();
  UrbanAreaExtractionViewGUI::Pointer view = UrbanAreaExtractionViewGUI::New();
  view->SetUrbanAreaExtractionController(controller);
  controller->SetView(view);

  return EXIT_SUCCESS;
}
