/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/
#include "itkExceptionObject.h"
#include "otbUrbanAreaExtractionModel.h"
#include "otbUrbanAreaExtractionViewGUI.h"
#include "otbUrbanAreaExtractionController.h"
//#include "otbImageFileReader.h"

using namespace otb;

int otbUrbanAreaExtractionOpenClose(int argc, char* argv[])
{

  /* Create the instances of the MVC application */
  UrbanAreaExtractionModel::Pointer model = UrbanAreaExtractionModel::GetInstance();
  UrbanAreaExtractionController::Pointer controller = UrbanAreaExtractionController::New();
  UrbanAreaExtractionViewGUI::Pointer view = UrbanAreaExtractionViewGUI::New();

  /* Plug the parts of the MVC Model */
  view->SetUrbanAreaExtractionController(controller);
  view->SetUrbanAreaExtractionModel(model);
  controller->SetView(view);
  controller->AddHandlers();

  view->InitWidgets();
  view->Show();

  if(argc==2)
    controller->OpenInputImage(argv[1]);

  if(argc==3)
    controller->OpenInputImage(argv[2]);

  if(argc==4)
    controller->OpenInputImage(argv[3]);

  view->QuitCallback();

  Fl::run();

  return EXIT_SUCCESS;
}
