/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/

#include "itkExceptionObject.h"
#include "otbUrbanAreaExtractionController.h"
#include "otbUrbanAreaExtractionViewGUI.h"
#include "itkIndex.h"


int otbUrbanAreaExtractionRunFull(int argc, char* argv[])
{
  typedef otb::UrbanAreaExtractionController ControllerType;
  typedef otb::UrbanAreaExtractionViewGUI ViewType;
 
  ControllerType::Pointer controller = ControllerType::New();
  ViewType::Pointer view = ViewType::New();
  controller->SetView(view);
  controller->AddHandlers();
  view->SetUrbanAreaExtractionController(controller);
 
  view->InitWidgets();
  view->Show();


  controller->OpenInputImage(argv[1]);
  Fl::check();

  controller->SetThreshold(250);
  controller->GetFocusingController()->GetFocusingModel()->Update();


  Fl::check();
  if(argc==4)
  {
    if( atoi(argv[2])==0)
    {
      controller->SaveVectorOnFull(argv[3]);
    }
  }

  return EXIT_SUCCESS;

}
