/*=========================================================================

  Program:   ORFEO Toolbox
  Language:  C++
  Date:      $Date$
  Version:   $Revision$


  Copyright (c) Centre National d'Etudes Spatiales. All rights reserved.
See OTBCopyright.txt for details.


    This software is distributed WITHOUT ANY WARRANTY; without even
     the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
     PURPOSE,  See the above copyright notices for more information.

=========================================================================*/

#include "itkExceptionObject.h"
#include "otbUrbanAreaExtractionController.h"
#include "otbUrbanAreaExtractionViewGUI.h"
#include "itkIndex.h"
#include "otbMsgReporter.h"

int otbUrbanAreaExtractionVD(int argc, char* argv[])
{
  typedef otb::UrbanAreaExtractionController ControllerType;
  typedef otb::UrbanAreaExtractionViewGUI ViewType;
 
  ControllerType::Pointer controller = ControllerType::New();
  ViewType::Pointer view = ViewType::New();
  controller->SetView(view);
  controller->AddHandlers();
  view->SetUrbanAreaExtractionController(controller);
 
  view->InitWidgets();
  view->Show();

  controller->OpenInputImage(argv[1]);
  Fl::check();

  itk::Index<> index1, index2;
  index1.Fill(20);
  index2.Fill(50);
  controller->GetFocusingController()->GetFocusingModel()->SetExtractRegionByIndex( index1, index2 );
  controller->GetFocusingController()->GetFocusingModel()->Update();

  if(argc>2)
    {
      controller->OpenInputVector(argv[2]);
      Fl::check();
    }

  //Fl::run();

/*  if(argc>3)
    {
      controller->SetDEMDirectory(argv[3]);
      controller->UseDEM(true);
      controller->UseDEM(false);
      controller->UseDEM(true);
      Fl::check();
    }*/
  
  return EXIT_SUCCESS;

}
